%define	debug_package		%{nil}

%define	rel			2
%define VirtualEnvironment      %{name}-%{version}-%{rel}
%define VirtualEnvironmentPath  %{_prefix}/local/lib/PythonVirtualEnvironments

%if 0%{?centos} || 0%{?amzn}
%define __python                %(echo which python3 | scl enable rh-python38 -)
%else
%define __python                /usr/bin/python3
%endif

%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^libffi-9c61262e.so.8.1.0
%define	_build_id_links none

Name:		hindsight
Version:	2021.12
Release:	%{rel}%{?dist}
Summary:	Internet history forensics for Google Chrome/Chromium
Group:		Applications
License:	GPL3
Source0:	%{name}-%{version}.tar.gz
Source1:	%{name}-%{version}.sh
Source2:	Hindsight_User_Guide-1.3.0.pdf
URL:		https://github.com/obsidianforensics/hindsight
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?amzn}
BuildRequires:  rh-python36-python-virtualenv
BuildRequires:  rh-python38-python rh-python38-python-devel
BuildRequires:  rust
Requires:       rh-python38-python
%endif

%if 0%{?centos} == 8 || 0%{?rhel} == 8
BuildRequires:  python3-virtualenv python38-devel python38
%endif

%if 0%{?centos} == 9 || 0%{?rhel} == 9
BuildRequires:  python3-virtualenv python3-devel python3
%endif

%if 0%{?centos} == 7 && 0%{?amzn} == 0
BuildRequires:  python36-virtualenv
BuildRequires:  rh-python38-python rh-python38-python-devel
Requires:       rh-python38-python
%endif

%if 0%{?fedora}
BuildRequires:  python3-virtualenv python3-devel
%endif

%description
Hindsight is a free tool for analyzing web artifacts. It started with the browsing history
of the Google Chrome web browser and has expanded to support other Chromium-based applications
(with more to come!). Hindsight can parse a number of different types of web artifacts, including
URLs, download history, cache records, bookmarks, autofill records, saved passwords, preferences,
browser extensions, HTTP cookies, and Local Storage records (HTML5 cookies). Once the data is
extracted from each file, it is correlated with data from other history files and placed in
a timeline.indsight is a free tool for analyzing web artifacts. It started with the browsing
history of the Google Chrome web browser and has expanded to support other Chromium-based
applications (with more to come!). Hindsight can parse a number of different types of web
artifacts, including URLs, download history, cache records, bookmarks, autofill records,
saved passwords, preferences, browser extensions, HTTP cookies, and Local Storage records
(HTML5 cookies). Once the data is extracted from each file, it is correlated with data from
other history files and placed in a timeline.

%prep
%setup -cT
sudo mkdir -p %{VirtualEnvironmentPath}
sudo chown %(id -u).%(id -g) %{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rm -rf %{VirtualEnvironment}

%if 0%{?amzn}
echo virtualenv -p $(echo which python3.8 | scl enable rh-python38 -) %{VirtualEnvironment} | scl enable rh-python36 -
%endif

%if 0%{?centos}0%{?amzn} == 70
echo virtualenv-3 -p $(echo which python3 | scl enable rh-python38 -) %{VirtualEnvironment} | scl enable rh-python38 -
%endif

%if 0%{?centos} == 8
virtualenv-3 -p $(which python3.8) %{VirtualEnvironment}
%endif

%if 0%{?centos} == 9
virtualenv -p $(which python3) %{VirtualEnvironment}
%endif

%if 0%{?fedora}
virtualenv %{VirtualEnvironment}
%endif

cd %{VirtualEnvironment}
tar zxf %{SOURCE0}

%build
cd %{VirtualEnvironmentPath}/%{VirtualEnvironment}
for p in pip py%{name} 'keyring>=21.2.1' 'pytz>=2020.1' 'pycryptodome>=3.9.7' 'pycryptodomex>=3.9.7' 'xlsxwriter>=1.2.9' \
	'bottle>=0.12.18' 'setuptools~=51.0.0' 'puremagic~=1.10' 'argparse~=1.4.0' 'dfir-unfurl'
do
	sh -c "source bin/activate; pip3 install --upgrade \"$p\""
done
sh -c "source bin/activate; cd %{name}-%{version}; python3 setup.py build"
tr -d '\r' < bin/%{name}.py > bin/%{name}.py-fixed
mv bin/%{name}.py-fixed bin/%{name}.py
tr -d '\r' < bin/%{name}_gui.py > bin/%{name}_gui.py-fixed
mv bin/%{name}_gui.py-fixed bin/%{name}_gui.py
chmod 755 bin/%{name}.py bin/%{name}_gui.py

%install
%{__mkdir_p} %{buildroot}/%{VirtualEnvironmentPath}
cd %{VirtualEnvironmentPath}
rm -rf %{VirtualEnvironment}/%{name}-%{version}
find %{VirtualEnvironment} | cpio -pdm %{buildroot}/%{VirtualEnvironmentPath}

for file in %{buildroot}%{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib/python3.*/site-packages/pymispwarninglists/data/misp-warninglists/tools/*.py \
	    %{buildroot}%{VirtualEnvironmentPath}/%{VirtualEnvironment}/lib*/python3.*/site-packages/google/protobuf/internal/_parameterized.py
do
	sed -i -e '1s/python$/python3/' $file
done

cd %{buildroot}/%{VirtualEnvironmentPath}/%{VirtualEnvironment}/bin
mkdir -p %{buildroot}/%{_bindir}
%__install -m755 %{SOURCE1} %{buildroot}%{_bindir}/%{name}
for t in %{name}.py %{name}_gui{,.py}
do
	ln %{buildroot}%{_bindir}/%{name} %{buildroot}%{_bindir}/$t
done

mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}/
install -m444 "%{SOURCE2}" %{buildroot}%{_docdir}/%{name}-%{version}

%clean
rm -rf ${RPM_BUILD_ROOT} %{VirtualEnvironmentPath}/%{VirtualEnvironment}

%files
%defattr(644,root,root,755)
%{VirtualEnvironmentPath}/%{VirtualEnvironment}
%attr(755, root, root)	%{_bindir}/%{name}
%attr(755, root, root)	%{_bindir}/%{name}_gui
%attr(755, root, root)	%{_bindir}/%{name}.py
%attr(755, root, root)	%{_bindir}/%{name}_gui.py
%{_docdir}/%{name}-%{version}

%changelog
* Mon Aug  8 2022 Lawrence R. Rogers <lrr@@cert.org> - 2021.12.16-2
- Release 2021.12.16-2
	Rebuilt to update lifcffi dependencies.

* Thu Dec 16 2021 Lawrence R. Rogers <lrr@@cert.org> - 2021.12.16-1
- Release 2021.12.16-1
	 Features
		Support for Chrome 91-96 by @obsidianforensics in #107, #117
		Add parsing of TransportSecurity file (HSTS settings).
		Add parsing of Session Storage #102
		Adds new "Site Setting" record type, which includes settings and preferences that are site-specific, including zoom, mute, hsts, engagement, and potentially more. #100
		More parsing of Preference items: network_prediction_options, password_manager, sessions.event_log, and sync settings. #101
	Minor Changes & Fixes
		Fix for case with missing Brave version by @cteodor in #99
		Update embedded ccl_chromium_indexeddb by @obsidianforensics in #102
		Timestamp sorting bug caused by incorrectly interpreting microsecond timestamps by @obsidianforensics in #103
		When searching for Profiles, don't follow symlinks (reports of loops,… by @obsidianforensics in #104
		Add try/except around reading Session Storage records in case of Leve… by @obsidianforensics in #106
		Two small quality of life improvements by @kumavis in #111
		chmod +x hindsight_gui.py by @kumavis in #112
		Report analysis session error by @kumavis in #113
		Add support for new Network subdirectory and files moved within it by @obsidianforensics in #116
	Packaging changes
		This version now builds the virtual environment at package building time, not at package installation time.

* Mon Apr 26 2021 Lawrence R. Rogers <lrr@@cert.org> - 2021.04.26-1
- Release 2021.04.26-1
	Features
		Parse "Site Characteristics Database" LevelDB @@obsidianforensics (#73)
		Add plugin to run Unfurl across Local Storage values @@obsidianforensics (#77)
		Add support for Chrome 88 - 90 (#72, #79)
	Minor Changes & Fixes
		Update Chrome Extensions parser to work on updated artifact types. @@obsidianforensics (#82)
		Added additional download interrupt_reason codes. Minor style fixes. @@obsidianforensics (#81)
		Add more exception handling around LevelDB records in case of corruption @@obsidianforensics (#78)
		Add check to ensure duration values in Media History are plausible @@obsidianforensics (#75)
		Fix bug in per_host_zoom_levels parsing @@obsidianforensics (#74)
		If autofill values are encrypted (as Edge's are), replace th